                      H89 PATCH FOR DBASEII VER 2.4

        The following modifications were created by D.    Pelowitz  after
        discovering  the Ashton-Tate dBASE install program doesn't set up
        the H89 cursor control keys on the keypad.  The patch  is  broken
        into  three  sections.    The  first installs the four arrow keys
        only.  It requires no code change and only changes the configura-
        tion  data  in  the  first record(sector) of DBASE.COM.  It is in
        effect only during the full screen edit mode.  The second part of
        the  patch  causes  the IC key to toggle "insert mode", DC key to
        toggle "delete record", IL  key  to  "insert  line",  DL  key  to
        "delete  line",  and HOME key to "write data to disk and continue
        normal operations." It changes actual code  and  also  adds  more
        code  around  the  configuration  data  down  in the first record
        (sector).  You will need  DDT.COM  or  ZDT.COM  to  install  this
        patch.    The  third  section  is the jump table out of the dBASE
        code.  It contains the address for each of the control  functions
        built into dBASE.  Use the following table to cross reference the
        H89 keyboard patches to the dBASE commands.

                       KEYPAD         dBASE cntrl function

                      1 (IL)                  ^N
                      2 (dn-arrow)            ^F ^J ^X
                      3 (DL)                  ^T
                      4 (lf-arrow)            ^H ^S
                      5 (HOME)                ^W
                      6 (rt-arrow)            ^D ^L
                      7 (IC)                  ^V
                      8 (up-arrow)            ^A ^K
                      9 (DC)                  ^U

	PART I.  Arrow key patch:
        This part of the patch may be installed on either version 2.3  or
        version 2.4.

        Use  INSTALL.COM  supplied  by  Ashton-Tate  to  do  the  initial
        installation using the following answers:

              Full screen? Y   (Note: If you don't want full screen there
                                is no point in any of this!)

	    Select system? C   (Note: This selects HEATH 89--this may
				vary, depending on the version of INSTALL
				you are running.)

                    Macro?     (Note: Just hit RETURN unless you want a
                                different macro substitution character.)

         Error Correction?     (Note: Hit RETURN unless you want no error
                                correction dialog.)

         Operating System? A   (Note: The normal H89 selection is A.)

                     Save? Y   (Note: There isn't much point in this 
                                exercise unless you install it.)

	You now have completed the normal H89 installation.  





        The following installs the arrow key patch by shifting the keypad
        when  in  the full screen edit mode.  It also sets the codes used
        by the software to select which function to perform.

        A>ZDT DBASE.COM
        ZDT VERS 1.4.14---CPU IS Z-80  (Note: ZDT works differently than DDT)
        NEXT  PC
        4D00 0100
        -S013C
        013C 06-08                      (Note: Sending 8 bytes.)
        -S0143
        0143 00-1B 00-75                (Note: Shift keypad)
        -S0148
        0148 01-02 00-1B 00-74          (Note: Unshift keypad)
        -S0157
        0157 00-5B 04-44 03-43 01-41 02-42   (Note: Watch for esc A to D)
        -^C
	A>SAVE 76 DBASE.COM		(Note: Use 'SAVE 71 DBASE.COM' on
					version 2.3b or c)

        Or using DDT.COM instead of ZDT.COM

        A>DDT DBASE.COM
        DDT  VERS 2.2
        NEXT  PC
        4D00 0100
        -S013C
        013C 06 08         (Note: Sending 8 bytes.)
        013D xx .          (Note: xx = don't care)
        -S0143
        0143 00 1B 
        0144 00 75         (Note: Shift keypad)
        0145 xx .          (Note: xx = don't care)
        -S0148
        0148 01 02 
        0149 00 1B
        014A 00 74         (Note: Unshift keypad)
        014B xx .          (Note: xx = don't care)
        -S0157
        0157 00 5B 
        0158 04 44
        0159 03 43
        015A 01 41
        015B 02 42         (Note: Watch for esc A to D)
        015C xx .          (Note: xx = don't care)
        -^C
	A>SAVE 76 DBASE.COM		(Note: Use 'SAVE 71 DBASE.COM' on
					version 2.3b or c)

        This completes the arrow key patch.

 





	PART II.  IC, DC, IL, DL, and HOME patch.  (Version 2.4 ONLY!)

        A>ZDT DBASE.COM
        ZDT VERS 1.4.14---CPU IS Z-80
        NEXT  PC
        4D00 0100
        -L029A
        029A  JNZ  02A2      (Note: This is the old code.)
        029D  CALL 3A62
        02A0  NOP
        02A1  NOP
        02A2  LXI  H,0158
        02A5  CMP  M
        02A6  JZ   0377
        02A9  INX  H
        02AA  CMP  M
        02AB  JZ   03A4
        02AE  INX  H
        -A029A
        029A  JZ 045A        (Note: Jump to this address for an esc @)
        029D  CPI 4C         (Note: Compare with L)
        029F  JZ 060E        (Note: Jump to this address for an esc L)
        02A2  JMP 0103       (Note: Go to next section of code)
        02A5
        -A0103
        0103  CPI 4D         (Note: Compare with M)
        0105  JMP 0117       (Note: Go to next section of code)
        0108
        -A0117
        0117  JZ 061B        (Note: Jump to this address for an esc M)
        011A  JMP 0133       (Note: Go to next section of code)
        011D
        -A0133
        0133  CPI 4E         (Note: Compare with N)
        0135  JZ 05E2        (Note: Jump to this address for an esc N)
        0138  JMP 014B       (Note: Go to next section of code)
        013B
        -A014B
        014B  CPI 48         (Note: Compare with H)
        014D  JZ 0628        (Note: Jump to this address for an esc H)
        0150  INX H          (Note: Bump HL pointer for esc A,B,C, and D)
        0151  JMP 02A5       (Note: Go check for esc A,B,C, and D)
        0154
        -S0157
        0157 5B-40           (Note: Change [(5Bh) to @(40h) for first test)
        -^C                  (Note: ZDT works a little different than DDT)
        A>SAVE 76 DBASE.COM

        If using DDT.COM, -S0157 and following will look like this:
        -S0157
        0157 5B 40
        0158 xx .            (Note: xx = don't care)
        -^C
        A>SAVE 76 DBASE.COM

        This completes the IC, DC, HOME, IL, and DL key patch.

        






        PART III.  Supplementary Data

        If you want to change the above patches to do any  of  the  other
        dBASE  functions  here is a list of the addresses in software for
        each of the control key functions.  You can change either or both
        the  jump  address  and/or  the  function  key  which selects it.
        Replace the address in the JZ commands in the patch to change  to
        a  different  dBASE function.  To change the function key, modify
        the byte after the CPI instructions.  The only exception  is  the
        "@"  which  is  at location 0157h in memory (0057h in DBASE.COM),
        immediately before the codes for the arrow keys.

                       ^A=034E  ^H=0377  ^O=027A  ^V=045A
                       ^B=0644  ^I=027A  ^P=027A  ^W=0628
                       ^C=0554  ^J=05B0  ^Q=02FE  ^X=05B0
                       ^D=03A4  ^K=034E  ^R=055F  ^Y=0522
                       ^E=034E  ^L=03A4  ^S=0377  ^Z=0631
                       ^F=05B0  ^M=056A  ^T=061B
                       ^G=0478  ^N=060E  ^U=05E2
